unit uSingleton;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
    TMySplashEvent = procedure(Sender:TObject; Param1:string; Param2:Integer) of object;

    { TSSettings }

    TSSettings = class(TObject)
    private
      FMySplashEvent : TMySplashEvent;
      FiCallCount: integer;
      FsCategories: string;

    protected
      {$WARNINGS OFF}
      constructor Create;
      {$WARNINGS ON}

    public
      destructor Destroy; override;
      procedure LoadInitialValues;
      property psCategories:string Read FsCategories;
      property piCallCount:integer read FiCallCount default 0;
      procedure Testlog;
    published
      property MySplashEvent:TMySplashEvent read FMySplashEvent write FMySplashEvent;
end;


function Settings: TSSettings;


implementation

function Settings: TSSettings;
const _Settings: TSSettings = nil; // globale variable die Prozedur lokal ist
begin
  if not Assigned(_Settings) then
  begin
    _Settings := TSSettings.Create;
    _Settings.LoadInitialValues; // beim ersten Aufruf Einstellungen laden
  end;
  Result := _Settings
end;

{ TSettings }
constructor TSSettings.Create;
begin
  inherited Create;
  FiCallCount:=FiCallCount+1;

end;

destructor TSSettings.Destroy;
begin
  inherited Destroy;
end;

procedure TSSettings.LoadInitialValues;
begin
  FsCategories:='4711';
end;

procedure TSSettings.Testlog;
begin
  if Assigned(FMySplashEvent) then FMySplashEvent(Self,'TSSettings Singleton was created',1);
end;

{
//initialization und finalization überlasse ich nicht dem Compiler
// wird in eigener Unit f alle nötigen Singletons erledigt -> uGlobalInit

initialization
  // Settings;   //würde zu einer nicht kontrollierbaren Reihenfolge führen
finalization
   //freeandnil(_Settings);
}
end.

